// Enchanter
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <cstdlib>
#include <cstring>
#include "ghost.h"

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    WCHAR szText[128];
    wsprintfW(szText, L"This window HWND is 0x%p", hwnd);
    SetDlgItemTextW(hwnd, stc1, szText);

    SetDlgItemTextW(hwnd, edt1, L"0x");
    return TRUE;
}

void OnOK(HWND hwnd)
{
    WCHAR szText[128];
    GetDlgItemTextW(hwnd, edt1, szText, ARRAYSIZE(szText));

    HWND hwndTarget = (HWND)(ULONG_PTR)wcstoul(szText, NULL, 0);

    if (!IsWindow(hwndTarget))
    {
        MessageBoxW(hwnd, L"Invalid HWND", NULL, MB_ICONERROR);
    }
    else
    {
        if (IntIsEnchanting(hwndTarget))
        {
            if (IntUnenchantWindow(hwndTarget))
            {
                SetDlgItemTextW(hwnd, IDOK, L"Enchant Now!");
                MessageBoxW(hwnd, L"Unechanted!", NULL, MB_ICONINFORMATION);
            }
            else
            {
                MessageBoxW(hwnd, L"Unable to unenchant!", NULL, MB_ICONINFORMATION);
            }
        }
        else if (IntEnchantWindow(hwndTarget))
        {
            SetDlgItemTextW(hwnd, IDOK, L"Unenchant!");
            MessageBoxW(hwnd, L"Enchanted!", NULL, MB_ICONINFORMATION);
        }
        else
        {
            MessageBoxW(hwnd, L"Unable to enchant!", NULL, MB_ICONINFORMATION);
        }
    }
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
        OnOK(hwnd);
        break;
    case IDCANCEL:
        EndDialog(hwnd, id);
        break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBoxW(hInstance, MAKEINTRESOURCEW(1), NULL, DialogProc);
    return 0;
}
